/*
Author: Jelle Geerts

Usage of the works is permitted provided that this instrument is
retained with the works, so that any entity that uses the works is
notified of this instrument.

DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
*/

function KeePassHelper_AppInfo() {
    KeePassHelper_AppInfo.FIREFOX = 0;
    KeePassHelper_AppInfo.THUNDERBIRD = 1;
    KeePassHelper_AppInfo.SEAMONKEY = 2;

    (function () {
        var appNames = [],
            xulAppInfo,
            i, j;

        appNames[KeePassHelper_AppInfo.FIREFOX] = [
            "Firefox",
            "Iceweasel",
            "Pale Moon",
            "Cyberfox",
            "IceDragon"
        ];
        appNames[KeePassHelper_AppInfo.THUNDERBIRD] = [
            "Thunderbird",
            "Icedove"
        ];
        appNames[KeePassHelper_AppInfo.SEAMONKEY] = [
            "SeaMonkey",
            "Iceape"
        ];

        xulAppInfo = Components.classes["@mozilla.org/xre/app-info;1"]
            .getService(Components.interfaces.nsIXULAppInfo);
        for (i = 0; i < appNames.length; ++i) {
            for (j = 0; j < appNames[i].length; ++j) {
                if (appNames[i][j] === xulAppInfo.name) {
                    KeePassHelper_AppInfo.app = i;
                    return;
                }
            }
        }

        dump("[KeePass Helper] AppInfo: unrecognized application name `" + xulAppInfo.name + "'.\n");
    })();
}

/*
 * Parameters:
 *   app [in]
 *     One of the KeePassHelper_AppInfo.YYY constants.
 */
KeePassHelper_AppInfo.isApp = function (app) {
    return KeePassHelper_AppInfo.app === app;
};

KeePassHelper_AppInfo.isFirefox = function () {
    return KeePassHelper_AppInfo.isApp(KeePassHelper_AppInfo.FIREFOX);
};

KeePassHelper_AppInfo.isThunderbird = function () {
    return KeePassHelper_AppInfo.isApp(KeePassHelper_AppInfo.THUNDERBIRD);
};

KeePassHelper_AppInfo.isSeaMonkey = function () {
    return KeePassHelper_AppInfo.isApp(KeePassHelper_AppInfo.SEAMONKEY);
};

KeePassHelper_AppInfo.isFirefoxOrSeaMonkey = function () {
    return (
        KeePassHelper_AppInfo.isApp(KeePassHelper_AppInfo.FIREFOX) ||
        KeePassHelper_AppInfo.isApp(KeePassHelper_AppInfo.SEAMONKEY));
};

KeePassHelper_AppInfo.isThunderbirdOrSeaMonkey = function () {
    return (
        KeePassHelper_AppInfo.isApp(KeePassHelper_AppInfo.THUNDERBIRD) ||
        KeePassHelper_AppInfo.isApp(KeePassHelper_AppInfo.SEAMONKEY));
};

KeePassHelper_AppInfo();
